Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.jstacs.models.hmm.states.emissions
Class MixtureEmission

    java.lang.Object
      de.jstacs.models.hmm.states.emissions.MixtureEmission

All Implemented Interfaces:
  Emission, Storable, Cloneable

    public final class MixtureEmission

extends Object
implements Emission

This class implements a mixture of `Emission`s.

Author:
  Jens Keilwagen

Constructor Summary
`MixtureEmission(Emission[] emission, double[] hyperParameters)` The main constructor creating a `MixtureEmission` from a set of emissions.
`MixtureEmission(StringBuffer xml)` The standard constructor for the interface `Storable`.

Method Summary
`void` | `addToStatistic(boolean forward, int startPos, int endPos, double weight, Sequence seq)` This method adds the `weight` to the internal sufficient statistic.
`MixtureEmission` | `clone()`
`void` | `estimateFromStatistic()` This method estimates the parameters from the internal sufficient statistic.
`AlphabetContainer` | `getAlphabetContainer()` This method returns the `AlphabetContainer` of this emission.
`double` | `getLogPriorTerm()` Returns a value that is proportional to the log of the prior.
`double` | `getLogProbFor(boolean forward, int startPos, int endPos, Sequence seq)` This method computes the logarithm of the likelihood.
`String` | `getNodeLabel(double weight, String name, NumberFormat nf)` Returns the graphviz label of the node containing this emission.
`String` | `getNodeShape(boolean forward)` Returns the graphviz string for the shape of the node.
`void` | `initializeFunctionRandomly()` This method initializes the emission randomly.
`void` | `resetStatistic()` This method resets the internal sufficient statistic.
`StringBuffer` | `toXML()` This method returns an XML representation as `StringBuffer` of an instance of the implementing class.

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MixtureEmission

    public MixtureEmission(Emission[] emission,
                           double[] hyperParameters)
                    throws CloneNotSupportedException

  The main constructor creating a `MixtureEmission` from a set of emissions.

  Parameters:
    `emission` - the individual emissions
    `hyperParameters` - the hyper parameters for each component
  Throws:
    `CloneNotSupportedException` - if the emission could not be cloned

### MixtureEmission

    public MixtureEmission(StringBuffer xml)
                    throws NonParsableException

  The standard constructor for the interface `Storable`. Constructs an `MixtureEmission` out of an XML representation.

  Parameters:
    `xml` - the XML representation as `StringBuffer`
  Throws:
    `NonParsableException` - if the `MixtureEmission` could not be reconstructed out of the `StringBuffer` `xml`

Method Detail

### toXML

    public StringBuffer toXML()

  Description copied from interface: `Storable`
  This method returns an XML representation as `StringBuffer` of an instance of the implementing class.

  Specified by:
    `toXML` in interface `Storable`
  Returns:
    the XML representation

### clone

    public MixtureEmission clone()
                          throws CloneNotSupportedException

  Overrides:
    `clone` in class `Object`
  Throws:
    `CloneNotSupportedException`

### addToStatistic

    public void addToStatistic(boolean forward,
                               int startPos,
                               int endPos,
                               double weight,
                               Sequence seq)
                        throws OperationNotSupportedException

  Description copied from interface: `Emission`
  This method adds the `weight` to the internal sufficient statistic.

  Specified by:
    `addToStatistic` in interface `Emission`
  Parameters:
    `forward` - whether to use the forward or the reverse strand
    `startPos` - the start position
    `endPos` - the end position
    `weight` - the weight of the sequence
    `seq` - the sequence
  Throws:
    `OperationNotSupportedException` - if `forward=false` and the reverse complement of the sequence `seq` is not defined

### estimateFromStatistic

    public void estimateFromStatistic()

  Description copied from interface: `Emission`
  This method estimates the parameters from the internal sufficient statistic.

  Specified by:
    `estimateFromStatistic` in interface `Emission`

### getAlphabetContainer

    public AlphabetContainer getAlphabetContainer()

  Description copied from interface: `Emission`
  This method returns the `AlphabetContainer` of this emission.

  Specified by:
    `getAlphabetContainer` in interface `Emission`
  Returns:
    the `AlphabetContainer` of this emission

### getLogPriorTerm

    public double getLogPriorTerm()

  Description copied from interface: `Emission`
  Returns a value that is proportional to the log of the prior. For maximum likelihood (ML) 0 should be returned.

  Specified by:
    `getLogPriorTerm` in interface `Emission`
  Returns:
    a value that is proportional to the log of the prior
  See Also:
    `Model.getLogPriorTerm()`

### getLogProbFor

    public double getLogProbFor(boolean forward,
                                int startPos,
                                int endPos,
                                Sequence seq)
                         throws OperationNotSupportedException

  Description copied from interface: `Emission`
  This method computes the logarithm of the likelihood.

  Specified by:
    `getLogProbFor` in interface `Emission`
  Parameters:
    `forward` - whether to use the forward or the reverse strand
    `startPos` - the start position
    `endPos` - the end position
    `seq` - the sequence
  Returns:
    the logarithm of the probability
  Throws:
    `OperationNotSupportedException` - if `forward=false` and the reverse complement of the sequence `seq` is not defined

### initializeFunctionRandomly

    public void initializeFunctionRandomly()

  Description copied from interface: `Emission`
  This method initializes the emission randomly.

  Specified by:
    `initializeFunctionRandomly` in interface `Emission`

### resetStatistic

    public void resetStatistic()

  Description copied from interface: `Emission`
  This method resets the internal sufficient statistic.

  Specified by:
    `resetStatistic` in interface `Emission`

### getNodeShape

    public String getNodeShape(boolean forward)

  Description copied from interface: `Emission`
  Returns the graphviz string for the shape of the node.

  Specified by:
    `getNodeShape` in interface `Emission`
  Parameters:
    `forward` - if this emission is used on the forward strand
  Returns:
    the shape

### getNodeLabel

    public String getNodeLabel(double weight,
                               String name,
                               NumberFormat nf)

  Description copied from interface: `Emission`
  Returns the graphviz label of the node containing this emission.

  Specified by:
    `getNodeLabel` in interface `Emission`
  Parameters:
    `weight` - the weight of the node which is represented by the color of the node, or -1 for no representation, i.e., white background
    `name` - the name of the state using this emission
    `nf` - the `NumberFormat` for formatting the textual representation of this emission
  Returns:
    the label

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD